#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>

#include "io.h"
#include "json.h"


int use_pkgng()
{
    char *fp;
    struct stat sb;

    asprintf(&fp, "%s/sbin/pkg", getenv("LOCALBASE") ? getenv("LOCALBASE") : "/usr/local");
    int ret = stat(fp, &sb);
    free(fp);

    if(! ret) {
        ret = system("pkg info pkg >/dev/null");
    }

    return ! ret;
}

static void split_cat_name(char *buff, char *cat, char *name)
{
    int size = strlen(buff);
    int i = 0;

    for(; i < size; i++) {
        if(buff[i] == '/') break;
    }

    bzero(cat, size);
    bzero(name, size);

    strncpy(cat, buff, i);
    strncpy(name, buff+i+1, size-i-2);
}

extern void build_pkg_info()
{
    FILE *INFO;
    char buff[80], cat[80], name[80];

    if(use_pkgng()) {
        INFO = popen("pkg info -aoq", "r");
    } else {
        INFO = popen("pkg_info -ao", "r");
    }

    while(fgets(buff, 80, INFO)) {
        if(strstr(buff, "/")) {
            split_cat_name(buff, cat, name);
            set_pkg_info(cat, name);
        }
    }

    pclose(INFO);
}

extern void build_sys_info()
{
    struct sys_info info;

    info.system = uname("-s");
    if(strcmp(info.system, "FreeBSD")) exit(1);

    info.version = uname("-r");
    info.machine = uname("-p");

    set_sys_info(info);

    free(info.system);
    free(info.version);
    free(info.machine);
}
